precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float effectValue;

#define N(a) (a.yx*vec2(1.0, -1.0))
float edge(vec2 p, float step)
{
    float dif = 0.0;
    float prsn = 4.0;
    vec4 currentColor =  texture2D(inputImageTexture, p);

    for (float i = -prsn; i <= prsn; i++)
    {
        for (float j = -prsn; j <= prsn; j++)
        {
            vec4 disColor = texture2D(inputImageTexture, p + step * vec2(i, j));
            dif += distance(currentColor.rgb, disColor.rgb);
        }
    }
    float neighborCount =  pow(prsn * 2.0 + 1.0, 2.0);
    float maxDif = neighborCount * distance(vec3(1.0, 1.0, 1.0), vec3(0.0, 0.0, 0.0));
    float isEdge = dif / sqrt(maxDif);
    //防止纯色图融合出现灰线的情况
    return isEdge < 0.07 ? 0.0 :  isEdge;
}

void main()
{
    vec2 uv = textureCoordinate;
    vec4 originalColor = texture2D(inputImageTexture, uv);
    originalColor.rgb *= 1.0 - edge(uv, 0.0005);
    float gray = 0.299*originalColor.r + 0.587*originalColor.g + 0.114*originalColor.b;
    originalColor.rgb += 0.24 * (1.0 - gray);
    gl_FragColor = originalColor;
}